import { NodeOptions } from '@highlight-run/node';
export { H } from '@highlight-run/node';
import { ExceptionFilter, OnApplicationShutdown, HttpAdapterHost, ArgumentsHost, ConsoleLogger } from '@nestjs/common';

declare class HighlightErrorFilter implements ExceptionFilter, OnApplicationShutdown {
    private readonly httpAdapterHost;
    readonly opts: NodeOptions;
    constructor(httpAdapterHost: HttpAdapterHost, opts: NodeOptions);
    catch(exception: Error, host: ArgumentsHost): void;
    onApplicationShutdown(signal?: string): Promise<void>;
}
declare class HighlightLogger extends ConsoleLogger implements OnApplicationShutdown {
    readonly opts: NodeOptions;
    constructor(opts: NodeOptions);
    log(message: string, context?: string, asBreadcrumb?: boolean): void;
    error(message: string, trace?: string, context?: string): void;
    warn(message: string, context?: string, asBreadcrumb?: boolean): void;
    debug(message: string, context?: string, asBreadcrumb?: boolean): void;
    verbose(message: string, context?: string, asBreadcrumb?: boolean): void;
    onApplicationShutdown(signal?: string): Promise<void>;
}
declare class HighlightModule {
    static forRoot(options: NodeOptions): {
        exports: (typeof HighlightErrorFilter | typeof HighlightLogger)[];
        module: typeof HighlightModule;
        providers: (typeof HighlightErrorFilter | typeof HighlightLogger)[];
    };
    static forRootAsync(options: NodeOptions): Promise<{
        exports: (typeof HighlightErrorFilter | typeof HighlightLogger)[];
        module: typeof HighlightModule;
        providers: (typeof HighlightErrorFilter | typeof HighlightLogger)[];
    }>;
}

export { HighlightErrorFilter, HighlightLogger, HighlightModule };
